package com.example.model;

@io.swagger.annotations.ApiModel(value = "AnswerRequest")
@javax.xml.bind.annotation.XmlRootElement(name = "AnswerRequest")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class AnswerRequest implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID questionId = null;
	private java.lang.Integer intValue = null;
	private java.lang.String stringValue = null;
	private java.util.List<java.lang.Integer> intValueArray = null;
	private java.lang.String otherTitle = null;
	private java.lang.Boolean notApplicable = null;
	
	/**
	 * question uuid to map to this answer
	 */
	public AnswerRequest questionId(java.util.UUID questionId) {
		setQuestionId(questionId);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "question uuid to map to this answer")
	@com.fasterxml.jackson.annotation.JsonProperty("questionId")
	public java.util.UUID getQuestionId() {
		return this.questionId;
	}
	public void setQuestionId(java.util.UUID questionId) {
		this.questionId = questionId;
	}
	
	/**
	 * in case of scale, matrix-subqueston, multi-single and multi-long-single questions
	 */
	public AnswerRequest intValue(java.lang.Integer intValue) {
		setIntValue(intValue);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "in case of scale, matrix-subqueston, multi-single and multi-long-single questions")
	@com.fasterxml.jackson.annotation.JsonProperty("intValue")
	public java.lang.Integer getIntValue() {
		return this.intValue;
	}
	public void setIntValue(java.lang.Integer intValue) {
		this.intValue = intValue;
	}
	
	/**
	 * in case of free text answer OR other question, that has text field,
	 */
	public AnswerRequest stringValue(java.lang.String stringValue) {
		setStringValue(stringValue);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "in case of free text answer OR other question, that has text field,")
	@com.fasterxml.jackson.annotation.JsonProperty("stringValue")
	public java.lang.String getStringValue() {
		return this.stringValue;
	}
	public void setStringValue(java.lang.String stringValue) {
		this.stringValue = stringValue;
	}
	
	/**
	 * in case of multi-multi question list of indices of selected options is set here
	 */
	public AnswerRequest intValueArray(java.util.List<java.lang.Integer> intValueArray) {
		setIntValueArray(intValueArray);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "in case of multi-multi question list of indices of selected options is set here")
	@com.fasterxml.jackson.annotation.JsonProperty("intValueArray")
	@javax.validation.Valid
	public java.util.List<java.lang.Integer> getIntValueArray() {
		return this.intValueArray;
	}
	public void setIntValueArray(java.util.List<java.lang.Integer> intValueArray) {
		this.intValueArray = intValueArray;
	}
	public void addIntValueArray(int intValueArray) {
		if (this.intValueArray == null) {
			this.intValueArray = new java.util.ArrayList<java.lang.Integer>();
		}
		this.intValueArray.add(intValueArray);
	}
	
	/**
	 * when matrix-subqueston or scale question is set to require other title
	 */
	public AnswerRequest otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when matrix-subqueston or scale question is set to require other title")
	@com.fasterxml.jackson.annotation.JsonProperty("otherTitle")
	public java.lang.String getOtherTitle() {
		return this.otherTitle;
	}
	public void setOtherTitle(java.lang.String otherTitle) {
		this.otherTitle = otherTitle;
	}
	
	/**
	 * Set to &#x60;true&#x60; if the participant indicated the question is not-applicable.
	 */
	public AnswerRequest notApplicable(java.lang.Boolean notApplicable) {
		setNotApplicable(notApplicable);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Set to `true` if the participant indicated the question is not-applicable.")
	@com.fasterxml.jackson.annotation.JsonProperty("notApplicable")
	public java.lang.Boolean getNotApplicable() {
		return this.notApplicable;
	}
	public void setNotApplicable(java.lang.Boolean notApplicable) {
		this.notApplicable = notApplicable;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		AnswerRequest answerRequest = (AnswerRequest) o;
		return java.util.Objects.equals(this.questionId, answerRequest.questionId) &&
				java.util.Objects.equals(this.intValue, answerRequest.intValue) &&
				java.util.Objects.equals(this.stringValue, answerRequest.stringValue) &&
				java.util.Objects.equals(this.intValueArray, answerRequest.intValueArray) &&
				java.util.Objects.equals(this.otherTitle, answerRequest.otherTitle) &&
				java.util.Objects.equals(this.notApplicable, answerRequest.notApplicable);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.questionId, this.intValue, this.stringValue, this.intValueArray, this.otherTitle, this.notApplicable);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class AnswerRequest {\n");
		
		sb.append("    questionId: ").append(toIndentedString(this.questionId)).append("\n");
		sb.append("    intValue: ").append(toIndentedString(this.intValue)).append("\n");
		sb.append("    stringValue: ").append(toIndentedString(this.stringValue)).append("\n");
		sb.append("    intValueArray: ").append(toIndentedString(this.intValueArray)).append("\n");
		sb.append("    otherTitle: ").append(toIndentedString(this.otherTitle)).append("\n");
		sb.append("    notApplicable: ").append(toIndentedString(this.notApplicable)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
