package com.example.model;

/**
 * The individual report result for a survey.
 */
@io.swagger.annotations.ApiModel(value = "IndividualReport", description = "The individual report result for a survey.")
@javax.xml.bind.annotation.XmlRootElement(name = "IndividualReport")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class IndividualReport implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@io.swagger.annotations.ApiModel(value = "")
	public static class Section implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		@javax.xml.bind.annotation.XmlType(name = "LayoutEnum")
		@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
		public enum LayoutEnum {
			@javax.xml.bind.annotation.XmlEnumValue("icons") ICONS("icons"), 
			@javax.xml.bind.annotation.XmlEnumValue("summary") SUMMARY("summary"), 
			@javax.xml.bind.annotation.XmlEnumValue("ranges") RANGES("ranges");
			
			private java.lang.String value;
			
			LayoutEnum(java.lang.String v) {
				value = v;
			}
			
			@com.fasterxml.jackson.annotation.JsonValue
			public String value() {
				return value;
			}
			
			@Override
			public String toString() {
				return String.valueOf(value);
			}
			
			public static LayoutEnum fromValue(String v) {
				for (LayoutEnum b : LayoutEnum.values()) {
					if (String.valueOf(b.value).equals(v)) {
						return b;
					}
				}
				return null;
			}
		}
		
		@io.swagger.annotations.ApiModel(value = "")
		public static class Grouping implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			@io.swagger.annotations.ApiModel(value = "")
			public static class Group implements java.io.Serializable {
			
				private static final long serialVersionUID = 1L;
				private java.lang.String title = null;
				private java.lang.String code = null;
				
				/**
				 * The title of the group. e.g. Significantly stressed
				 */
				public Group title(java.lang.String title) {
					setTitle(title);
					return this;
				}
				
				@io.swagger.annotations.ApiModelProperty(required = true, value = "The title of the group. e.g. Significantly stressed")
				@com.fasterxml.jackson.annotation.JsonProperty("title")
				@javax.validation.constraints.NotNull
				public java.lang.String getTitle() {
					return this.title;
				}
				public void setTitle(java.lang.String title) {
					this.title = title;
				}
				
				/**
				 * The internal code of the group, used to reference a group in an aspect.
				 */
				public Group code(java.lang.String code) {
					setCode(code);
					return this;
				}
				
				@io.swagger.annotations.ApiModelProperty(required = true, value = "The internal code of the group, used to reference a group in an aspect.")
				@com.fasterxml.jackson.annotation.JsonProperty("code")
				@javax.validation.constraints.NotNull
				public java.lang.String getCode() {
					return this.code;
				}
				public void setCode(java.lang.String code) {
					this.code = code;
				}
				
				@Override
				public boolean equals(java.lang.Object o) {
					if (this == o) {
						return true;
					}
					if (o == null || getClass() != o.getClass()) {
						return false;
					}
					Group group = (Group) o;
					return java.util.Objects.equals(this.title, group.title) &&
							java.util.Objects.equals(this.code, group.code);
				}
				
				@Override
				public int hashCode() {
					return java.util.Objects.hash(this.title, this.code);
				}
				
				@Override
				public String toString() {
					StringBuilder sb = new StringBuilder();
					sb.append("class Group {\n");
					
					sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
					sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
					sb.append("}");
					return sb.toString();
				}
				
				/**
				 * Convert the given object to string with each line indented by 4 spaces
				 * (except the first line).
				 */
				private String toIndentedString(java.lang.Object o) {
					if (o == null) {
						return "null";
					}
					return o.toString().replace("\n", "\n    ");
				}
				
			}
			
			private java.lang.String title = null;
			private java.lang.String intro = null;
			private java.util.List<com.example.model.IndividualReport.Section.Grouping.Group> groups = new java.util.ArrayList<com.example.model.IndividualReport.Section.Grouping.Group>();
			
			/**
			 * The title of the grouping. e.g. Your result breakdown
			 */
			public Grouping title(java.lang.String title) {
				setTitle(title);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "The title of the grouping. e.g. Your result breakdown")
			@com.fasterxml.jackson.annotation.JsonProperty("title")
			@javax.validation.constraints.NotNull
			public java.lang.String getTitle() {
				return this.title;
			}
			public void setTitle(java.lang.String title) {
				this.title = title;
			}
			
			/**
			 */
			public Grouping intro(java.lang.String intro) {
				setIntro(intro);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("intro")
			public java.lang.String getIntro() {
				return this.intro;
			}
			public void setIntro(java.lang.String intro) {
				this.intro = intro;
			}
			
			/**
			 */
			public Grouping groups(java.util.List<com.example.model.IndividualReport.Section.Grouping.Group> groups) {
				setGroups(groups);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("groups")
			@javax.validation.Valid
			@javax.validation.constraints.NotNull
			public java.util.List<com.example.model.IndividualReport.Section.Grouping.Group> getGroups() {
				return this.groups;
			}
			public void setGroups(java.util.List<com.example.model.IndividualReport.Section.Grouping.Group> groups) {
				this.groups = groups;
			}
			public void addGroup(com.example.model.IndividualReport.Section.Grouping.Group group) {
				if (this.groups == null) {
					this.groups = new java.util.ArrayList<com.example.model.IndividualReport.Section.Grouping.Group>();
				}
				this.groups.add(group);
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Grouping grouping = (Grouping) o;
				return java.util.Objects.equals(this.title, grouping.title) &&
						java.util.Objects.equals(this.intro, grouping.intro) &&
						java.util.Objects.equals(this.groups, grouping.groups);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.title, this.intro, this.groups);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Grouping {\n");
				
				sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
				sb.append("    intro: ").append(toIndentedString(this.intro)).append("\n");
				sb.append("    groups: ").append(toIndentedString(this.groups)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		@io.swagger.annotations.ApiModel(value = "")
		public static class Aspect implements java.io.Serializable {
		
			private static final long serialVersionUID = 1L;
			private java.lang.String name = null;
			private java.lang.String code = null;
			private java.lang.String icon = null;
			private java.math.BigDecimal score = new java.math.BigDecimal("0");
			private java.lang.String group = null;
			private com.example.model.ArticleSummary descriptionArticle = null;
			private java.util.List<com.example.model.ArticleSummary> articles = null;
			
			/**
			 */
			public Aspect name(java.lang.String name) {
				setName(name);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("name")
			@javax.validation.constraints.NotNull
			public java.lang.String getName() {
				return this.name;
			}
			public void setName(java.lang.String name) {
				this.name = name;
			}
			
			/**
			 */
			public Aspect code(java.lang.String code) {
				setCode(code);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "")
			@com.fasterxml.jackson.annotation.JsonProperty("code")
			public java.lang.String getCode() {
				return this.code;
			}
			public void setCode(java.lang.String code) {
				this.code = code;
			}
			
			/**
			 * The name of the icon to use for this aspect, if any.
			 */
			public Aspect icon(java.lang.String icon) {
				setIcon(icon);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "The name of the icon to use for this aspect, if any.")
			@com.fasterxml.jackson.annotation.JsonProperty("icon")
			public java.lang.String getIcon() {
				return this.icon;
			}
			public void setIcon(java.lang.String icon) {
				this.icon = icon;
			}
			
			/**
			 * A score from 0.0 to 1.0.
			 */
			public Aspect score(java.math.BigDecimal score) {
				setScore(score);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(required = true, value = "A score from 0.0 to 1.0.")
			@com.fasterxml.jackson.annotation.JsonProperty("score")
			@javax.validation.constraints.NotNull
			public java.math.BigDecimal getScore() {
				return this.score;
			}
			public void setScore(java.math.BigDecimal score) {
				this.score = score;
			}
			
			/**
			 * The code of the group that this aspect is in, if any.
			 */
			public Aspect group(java.lang.String group) {
				setGroup(group);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "The code of the group that this aspect is in, if any.")
			@com.fasterxml.jackson.annotation.JsonProperty("group")
			public java.lang.String getGroup() {
				return this.group;
			}
			public void setGroup(java.lang.String group) {
				this.group = group;
			}
			
			/**
			 * An article that describes this aspect, if any.
			 */
			public Aspect descriptionArticle(com.example.model.ArticleSummary descriptionArticle) {
				setDescriptionArticle(descriptionArticle);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "An article that describes this aspect, if any.")
			@com.fasterxml.jackson.annotation.JsonProperty("descriptionArticle")
			@javax.validation.Valid
			public com.example.model.ArticleSummary getDescriptionArticle() {
				return this.descriptionArticle;
			}
			public void setDescriptionArticle(com.example.model.ArticleSummary descriptionArticle) {
				this.descriptionArticle = descriptionArticle;
			}
			
			/**
			 * Additional articles to be shown to the individual that relate to this aspect.
			 */
			public Aspect articles(java.util.List<com.example.model.ArticleSummary> articles) {
				setArticles(articles);
				return this;
			}
			
			@io.swagger.annotations.ApiModelProperty(value = "Additional articles to be shown to the individual that relate to this aspect.")
			@com.fasterxml.jackson.annotation.JsonProperty("articles")
			@javax.validation.Valid
			public java.util.List<com.example.model.ArticleSummary> getArticles() {
				return this.articles;
			}
			public void setArticles(java.util.List<com.example.model.ArticleSummary> articles) {
				this.articles = articles;
			}
			public void addArticle(com.example.model.ArticleSummary article) {
				if (this.articles == null) {
					this.articles = new java.util.ArrayList<com.example.model.ArticleSummary>();
				}
				this.articles.add(article);
			}
			
			@Override
			public boolean equals(java.lang.Object o) {
				if (this == o) {
					return true;
				}
				if (o == null || getClass() != o.getClass()) {
					return false;
				}
				Aspect aspect = (Aspect) o;
				return java.util.Objects.equals(this.name, aspect.name) &&
						java.util.Objects.equals(this.code, aspect.code) &&
						java.util.Objects.equals(this.icon, aspect.icon) &&
						java.util.Objects.equals(this.score, aspect.score) &&
						java.util.Objects.equals(this.group, aspect.group) &&
						java.util.Objects.equals(this.descriptionArticle, aspect.descriptionArticle) &&
						java.util.Objects.equals(this.articles, aspect.articles);
			}
			
			@Override
			public int hashCode() {
				return java.util.Objects.hash(this.name, this.code, this.icon, this.score, this.group, this.descriptionArticle, this.articles);
			}
			
			@Override
			public String toString() {
				StringBuilder sb = new StringBuilder();
				sb.append("class Aspect {\n");
				
				sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
				sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
				sb.append("    icon: ").append(toIndentedString(this.icon)).append("\n");
				sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
				sb.append("    group: ").append(toIndentedString(this.group)).append("\n");
				sb.append("    descriptionArticle: ").append(toIndentedString(this.descriptionArticle)).append("\n");
				sb.append("    articles: ").append(toIndentedString(this.articles)).append("\n");
				sb.append("}");
				return sb.toString();
			}
			
			/**
			 * Convert the given object to string with each line indented by 4 spaces
			 * (except the first line).
			 */
			private String toIndentedString(java.lang.Object o) {
				if (o == null) {
					return "null";
				}
				return o.toString().replace("\n", "\n    ");
			}
			
		}
		
		private java.lang.String name = null;
		private java.lang.String code = null;
		private java.math.BigDecimal score = new java.math.BigDecimal("0");
		private java.lang.String minLabel = null;
		private java.lang.String midLabel = null;
		private java.lang.String maxLabel = null;
		private java.lang.String intro = null;
		private java.lang.String summary = null;
		private com.example.model.IndividualReport.Section.LayoutEnum layout = null;
		private java.util.List<com.example.model.ArticleSummary> articles = null;
		private java.util.List<com.example.model.IndividualReport.Section.Grouping> groupings = null;
		private java.util.List<com.example.model.IndividualReport.Section.Aspect> aspects = new java.util.ArrayList<com.example.model.IndividualReport.Section.Aspect>();
		
		/**
		 * The title of the section.
		 */
		public Section name(java.lang.String name) {
			setName(name);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "The title of the section.")
		@com.fasterxml.jackson.annotation.JsonProperty("name")
		@javax.validation.constraints.NotNull
		public java.lang.String getName() {
			return this.name;
		}
		public void setName(java.lang.String name) {
			this.name = name;
		}
		
		/**
		 * An internal code used to match a section of the report to some hard-coded functionality or styling.
		 */
		public Section code(java.lang.String code) {
			setCode(code);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "An internal code used to match a section of the report to some hard-coded functionality or styling.")
		@com.fasterxml.jackson.annotation.JsonProperty("code")
		public java.lang.String getCode() {
			return this.code;
		}
		public void setCode(java.lang.String code) {
			this.code = code;
		}
		
		/**
		 * A score from 0.0 to 1.0.
		 */
		public Section score(java.math.BigDecimal score) {
			setScore(score);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "A score from 0.0 to 1.0.")
		@com.fasterxml.jackson.annotation.JsonProperty("score")
		@javax.validation.constraints.NotNull
		public java.math.BigDecimal getScore() {
			return this.score;
		}
		public void setScore(java.math.BigDecimal score) {
			this.score = score;
		}
		
		/**
		 * The label for the minimum score.
		 */
		public Section minLabel(java.lang.String minLabel) {
			setMinLabel(minLabel);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "The label for the minimum score.")
		@com.fasterxml.jackson.annotation.JsonProperty("minLabel")
		public java.lang.String getMinLabel() {
			return this.minLabel;
		}
		public void setMinLabel(java.lang.String minLabel) {
			this.minLabel = minLabel;
		}
		
		/**
		 * The label for the middle score.
		 */
		public Section midLabel(java.lang.String midLabel) {
			setMidLabel(midLabel);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "The label for the middle score.")
		@com.fasterxml.jackson.annotation.JsonProperty("midLabel")
		public java.lang.String getMidLabel() {
			return this.midLabel;
		}
		public void setMidLabel(java.lang.String midLabel) {
			this.midLabel = midLabel;
		}
		
		/**
		 * The label for the maximum score.
		 */
		public Section maxLabel(java.lang.String maxLabel) {
			setMaxLabel(maxLabel);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "The label for the maximum score.")
		@com.fasterxml.jackson.annotation.JsonProperty("maxLabel")
		public java.lang.String getMaxLabel() {
			return this.maxLabel;
		}
		public void setMaxLabel(java.lang.String maxLabel) {
			this.maxLabel = maxLabel;
		}
		
		/**
		 * The introduction for this section.
		 */
		public Section intro(java.lang.String intro) {
			setIntro(intro);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "The introduction for this section.")
		@com.fasterxml.jackson.annotation.JsonProperty("intro")
		public java.lang.String getIntro() {
			return this.intro;
		}
		public void setIntro(java.lang.String intro) {
			this.intro = intro;
		}
		
		/**
		 * The summary of the participant&#x27;s results in this section.
		 */
		public Section summary(java.lang.String summary) {
			setSummary(summary);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "The summary of the participant's results in this section.")
		@com.fasterxml.jackson.annotation.JsonProperty("summary")
		public java.lang.String getSummary() {
			return this.summary;
		}
		public void setSummary(java.lang.String summary) {
			this.summary = summary;
		}
		
		/**
		 */
		public Section layout(com.example.model.IndividualReport.Section.LayoutEnum layout) {
			setLayout(layout);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("layout")
		@javax.validation.constraints.NotNull
		public com.example.model.IndividualReport.Section.LayoutEnum getLayout() {
			return this.layout;
		}
		public void setLayout(com.example.model.IndividualReport.Section.LayoutEnum layout) {
			this.layout = layout;
		}
		
		/**
		 * Articles to be shown to the individual that relate generally to this section.
		 */
		public Section articles(java.util.List<com.example.model.ArticleSummary> articles) {
			setArticles(articles);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "Articles to be shown to the individual that relate generally to this section.")
		@com.fasterxml.jackson.annotation.JsonProperty("articles")
		@javax.validation.Valid
		public java.util.List<com.example.model.ArticleSummary> getArticles() {
			return this.articles;
		}
		public void setArticles(java.util.List<com.example.model.ArticleSummary> articles) {
			this.articles = articles;
		}
		public void addArticle(com.example.model.ArticleSummary article) {
			if (this.articles == null) {
				this.articles = new java.util.ArrayList<com.example.model.ArticleSummary>();
			}
			this.articles.add(article);
		}
		
		/**
		 */
		public Section groupings(java.util.List<com.example.model.IndividualReport.Section.Grouping> groupings) {
			setGroupings(groupings);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("groupings")
		@javax.validation.Valid
		public java.util.List<com.example.model.IndividualReport.Section.Grouping> getGroupings() {
			return this.groupings;
		}
		public void setGroupings(java.util.List<com.example.model.IndividualReport.Section.Grouping> groupings) {
			this.groupings = groupings;
		}
		public void addGrouping(com.example.model.IndividualReport.Section.Grouping grouping) {
			if (this.groupings == null) {
				this.groupings = new java.util.ArrayList<com.example.model.IndividualReport.Section.Grouping>();
			}
			this.groupings.add(grouping);
		}
		
		/**
		 */
		public Section aspects(java.util.List<com.example.model.IndividualReport.Section.Aspect> aspects) {
			setAspects(aspects);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("aspects")
		@javax.validation.Valid
		@javax.validation.constraints.NotNull
		public java.util.List<com.example.model.IndividualReport.Section.Aspect> getAspects() {
			return this.aspects;
		}
		public void setAspects(java.util.List<com.example.model.IndividualReport.Section.Aspect> aspects) {
			this.aspects = aspects;
		}
		public void addAspect(com.example.model.IndividualReport.Section.Aspect aspect) {
			if (this.aspects == null) {
				this.aspects = new java.util.ArrayList<com.example.model.IndividualReport.Section.Aspect>();
			}
			this.aspects.add(aspect);
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Section section = (Section) o;
			return java.util.Objects.equals(this.name, section.name) &&
					java.util.Objects.equals(this.code, section.code) &&
					java.util.Objects.equals(this.score, section.score) &&
					java.util.Objects.equals(this.minLabel, section.minLabel) &&
					java.util.Objects.equals(this.midLabel, section.midLabel) &&
					java.util.Objects.equals(this.maxLabel, section.maxLabel) &&
					java.util.Objects.equals(this.intro, section.intro) &&
					java.util.Objects.equals(this.summary, section.summary) &&
					java.util.Objects.equals(this.layout, section.layout) &&
					java.util.Objects.equals(this.articles, section.articles) &&
					java.util.Objects.equals(this.groupings, section.groupings) &&
					java.util.Objects.equals(this.aspects, section.aspects);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.name, this.code, this.score, this.minLabel, this.midLabel, this.maxLabel, this.intro, this.summary, this.layout, this.articles, this.groupings, this.aspects);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Section {\n");
			
			sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
			sb.append("    code: ").append(toIndentedString(this.code)).append("\n");
			sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
			sb.append("    minLabel: ").append(toIndentedString(this.minLabel)).append("\n");
			sb.append("    midLabel: ").append(toIndentedString(this.midLabel)).append("\n");
			sb.append("    maxLabel: ").append(toIndentedString(this.maxLabel)).append("\n");
			sb.append("    intro: ").append(toIndentedString(this.intro)).append("\n");
			sb.append("    summary: ").append(toIndentedString(this.summary)).append("\n");
			sb.append("    layout: ").append(toIndentedString(this.layout)).append("\n");
			sb.append("    articles: ").append(toIndentedString(this.articles)).append("\n");
			sb.append("    groupings: ").append(toIndentedString(this.groupings)).append("\n");
			sb.append("    aspects: ").append(toIndentedString(this.aspects)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.lang.String oneWordSummary = null;
	private java.lang.String summary = null;
	private java.math.BigDecimal score = new java.math.BigDecimal("0");
	private java.lang.String minLabel = null;
	private java.lang.String midLabel = null;
	private java.lang.String maxLabel = null;
	private com.example.model.PersonSummary person = null;
	private java.util.List<com.example.model.IndividualReport.Section> sections = new java.util.ArrayList<com.example.model.IndividualReport.Section>();
	
	/**
	 * The one-word summary of the report, e.g. Surviving
	 */
	public IndividualReport oneWordSummary(java.lang.String oneWordSummary) {
		setOneWordSummary(oneWordSummary);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The one-word summary of the report, e.g. Surviving")
	@com.fasterxml.jackson.annotation.JsonProperty("oneWordSummary")
	@javax.validation.constraints.NotNull
	public java.lang.String getOneWordSummary() {
		return this.oneWordSummary;
	}
	public void setOneWordSummary(java.lang.String oneWordSummary) {
		this.oneWordSummary = oneWordSummary;
	}
	
	/**
	 * The summary of your report.
	 */
	public IndividualReport summary(java.lang.String summary) {
		setSummary(summary);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The summary of your report.")
	@com.fasterxml.jackson.annotation.JsonProperty("summary")
	@javax.validation.constraints.NotNull
	public java.lang.String getSummary() {
		return this.summary;
	}
	public void setSummary(java.lang.String summary) {
		this.summary = summary;
	}
	
	/**
	 * A score from 0.0 to 1.0.
	 */
	public IndividualReport score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "A score from 0.0 to 1.0.")
	@com.fasterxml.jackson.annotation.JsonProperty("score")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getScore() {
		return this.score;
	}
	public void setScore(java.math.BigDecimal score) {
		this.score = score;
	}
	
	/**
	 * The label for the minimum score.
	 */
	public IndividualReport minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The label for the minimum score.")
	@com.fasterxml.jackson.annotation.JsonProperty("minLabel")
	public java.lang.String getMinLabel() {
		return this.minLabel;
	}
	public void setMinLabel(java.lang.String minLabel) {
		this.minLabel = minLabel;
	}
	
	/**
	 * The label for the middle score.
	 */
	public IndividualReport midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The label for the middle score.")
	@com.fasterxml.jackson.annotation.JsonProperty("midLabel")
	public java.lang.String getMidLabel() {
		return this.midLabel;
	}
	public void setMidLabel(java.lang.String midLabel) {
		this.midLabel = midLabel;
	}
	
	/**
	 * The label for the maximum score.
	 */
	public IndividualReport maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The label for the maximum score.")
	@com.fasterxml.jackson.annotation.JsonProperty("maxLabel")
	public java.lang.String getMaxLabel() {
		return this.maxLabel;
	}
	public void setMaxLabel(java.lang.String maxLabel) {
		this.maxLabel = maxLabel;
	}
	
	/**
	 * The person who completed the survey, if known.
	 */
	public IndividualReport person(com.example.model.PersonSummary person) {
		setPerson(person);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The person who completed the survey, if known.")
	@com.fasterxml.jackson.annotation.JsonProperty("person")
	@javax.validation.Valid
	public com.example.model.PersonSummary getPerson() {
		return this.person;
	}
	public void setPerson(com.example.model.PersonSummary person) {
		this.person = person;
	}
	
	/**
	 */
	public IndividualReport sections(java.util.List<com.example.model.IndividualReport.Section> sections) {
		setSections(sections);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("sections")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.IndividualReport.Section> getSections() {
		return this.sections;
	}
	public void setSections(java.util.List<com.example.model.IndividualReport.Section> sections) {
		this.sections = sections;
	}
	public void addSection(com.example.model.IndividualReport.Section section) {
		if (this.sections == null) {
			this.sections = new java.util.ArrayList<com.example.model.IndividualReport.Section>();
		}
		this.sections.add(section);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		IndividualReport individualReport = (IndividualReport) o;
		return java.util.Objects.equals(this.oneWordSummary, individualReport.oneWordSummary) &&
				java.util.Objects.equals(this.summary, individualReport.summary) &&
				java.util.Objects.equals(this.score, individualReport.score) &&
				java.util.Objects.equals(this.minLabel, individualReport.minLabel) &&
				java.util.Objects.equals(this.midLabel, individualReport.midLabel) &&
				java.util.Objects.equals(this.maxLabel, individualReport.maxLabel) &&
				java.util.Objects.equals(this.person, individualReport.person) &&
				java.util.Objects.equals(this.sections, individualReport.sections);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.oneWordSummary, this.summary, this.score, this.minLabel, this.midLabel, this.maxLabel, this.person, this.sections);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class IndividualReport {\n");
		
		sb.append("    oneWordSummary: ").append(toIndentedString(this.oneWordSummary)).append("\n");
		sb.append("    summary: ").append(toIndentedString(this.summary)).append("\n");
		sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
		sb.append("    minLabel: ").append(toIndentedString(this.minLabel)).append("\n");
		sb.append("    midLabel: ").append(toIndentedString(this.midLabel)).append("\n");
		sb.append("    maxLabel: ").append(toIndentedString(this.maxLabel)).append("\n");
		sb.append("    person: ").append(toIndentedString(this.person)).append("\n");
		sb.append("    sections: ").append(toIndentedString(this.sections)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
