package com.example.model;

@io.swagger.annotations.ApiModel(value = "MatrixSubQuestion")
@javax.xml.bind.annotation.XmlRootElement(name = "MatrixSubQuestion")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class MatrixSubQuestion extends com.example.model.Question implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private boolean requiresOtherTitle = false;
	private java.lang.String notApplicableOption = null;
	
	/**
	 * question id
	 */
	@java.lang.Override
	public MatrixSubQuestion id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 * question title, e.g. How long have you worked for this organisation?
	 */
	@java.lang.Override
	public MatrixSubQuestion title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	/**
	 * Extra text to go underneath the title to clarify something about the question.
	 */
	@java.lang.Override
	public MatrixSubQuestion subtitle(java.lang.String subtitle) {
		setSubtitle(subtitle);
		return this;
	}
	
	/**
	 * Introductory text to the question.
	 */
	@java.lang.Override
	public MatrixSubQuestion introduction(java.lang.String introduction) {
		setIntroduction(introduction);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public MatrixSubQuestion answerIndex(java.lang.Integer answerIndex) {
		setAnswerIndex(answerIndex);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public MatrixSubQuestion answerIndices(java.util.List<java.lang.Integer> answerIndices) {
		setAnswerIndices(answerIndices);
		return this;
	}
	
	/**
	 * when available, string value that was put as an answer
	 */
	@java.lang.Override
	public MatrixSubQuestion answeredStringValue(java.lang.String answeredStringValue) {
		setAnsweredStringValue(answeredStringValue);
		return this;
	}
	
	/**
	 * when available, whether the user chose to mark this question as not applicable
	 */
	@java.lang.Override
	public MatrixSubQuestion answerNotApplicable(java.lang.Boolean answerNotApplicable) {
		setAnswerNotApplicable(answerNotApplicable);
		return this;
	}
	
	/**
	 * when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.
	 */
	@java.lang.Override
	public MatrixSubQuestion otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	/**
	 * indicates that the answer is not compulsory
	 */
	@java.lang.Override
	public MatrixSubQuestion optional(java.lang.Boolean optional) {
		setOptional(optional);
		return this;
	}
	
	/**
	 * indicates that the question is created as a part of custom question
	 */
	@java.lang.Override
	public MatrixSubQuestion custom(java.lang.Boolean custom) {
		setCustom(custom);
		return this;
	}
	
	/**
	 * indicates that the question is custom question and is a part of open survey, therefore it can&#x27;t be edited
	 */
	@java.lang.Override
	public MatrixSubQuestion locked(java.lang.Boolean locked) {
		setLocked(locked);
		return this;
	}
	
	/**
	 * true if matrix sub-question or scale question require user to set title
	 */
	public MatrixSubQuestion requiresOtherTitle(boolean requiresOtherTitle) {
		setRequiresOtherTitle(requiresOtherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "true if matrix sub-question or scale question require user to set title")
	@com.fasterxml.jackson.annotation.JsonProperty("requiresOtherTitle")
	@javax.validation.constraints.NotNull
	public boolean isRequiresOtherTitle() {
		return this.requiresOtherTitle;
	}
	public void setRequiresOtherTitle(boolean requiresOtherTitle) {
		this.requiresOtherTitle = requiresOtherTitle;
	}
	
	/**
	 * Contains the text label for a not-applicable option, if appropriate.
	 */
	public MatrixSubQuestion notApplicableOption(java.lang.String notApplicableOption) {
		setNotApplicableOption(notApplicableOption);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Contains the text label for a not-applicable option, if appropriate.")
	@com.fasterxml.jackson.annotation.JsonProperty("notApplicableOption")
	public java.lang.String getNotApplicableOption() {
		return this.notApplicableOption;
	}
	public void setNotApplicableOption(java.lang.String notApplicableOption) {
		this.notApplicableOption = notApplicableOption;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		MatrixSubQuestion matrixSubQuestion = (MatrixSubQuestion) o;
		return java.util.Objects.equals(this.requiresOtherTitle, matrixSubQuestion.requiresOtherTitle) &&
				java.util.Objects.equals(this.notApplicableOption, matrixSubQuestion.notApplicableOption);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.requiresOtherTitle, this.notApplicableOption);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class MatrixSubQuestion {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    requiresOtherTitle: ").append(toIndentedString(this.requiresOtherTitle)).append("\n");
		sb.append("    notApplicableOption: ").append(toIndentedString(this.notApplicableOption)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
