package com.example.model;

@io.swagger.annotations.ApiModel(value = "MultichoiceQuestion")
@javax.xml.bind.annotation.XmlRootElement(name = "MultichoiceQuestion")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class MultichoiceQuestion extends com.example.model.Question implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "MultichoiceTypeEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum MultichoiceTypeEnum {
		@javax.xml.bind.annotation.XmlEnumValue("single") SINGLE("single"), 
		@javax.xml.bind.annotation.XmlEnumValue("multi") MULTI("multi"), 
		@javax.xml.bind.annotation.XmlEnumValue("long-single") LONG_SINGLE("long-single");
		
		private java.lang.String value;
		
		MultichoiceTypeEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static MultichoiceTypeEnum fromValue(String v) {
			for (MultichoiceTypeEnum b : MultichoiceTypeEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	private java.util.List<java.lang.String> options = new java.util.ArrayList<java.lang.String>();
	private boolean allowOtherAnswer = false;
	private com.example.model.MultichoiceQuestion.MultichoiceTypeEnum multichoiceType = null;
	
	/**
	 * question id
	 */
	@java.lang.Override
	public MultichoiceQuestion id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 * question title, e.g. How long have you worked for this organisation?
	 */
	@java.lang.Override
	public MultichoiceQuestion title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	/**
	 * Extra text to go underneath the title to clarify something about the question.
	 */
	@java.lang.Override
	public MultichoiceQuestion subtitle(java.lang.String subtitle) {
		setSubtitle(subtitle);
		return this;
	}
	
	/**
	 * Introductory text to the question.
	 */
	@java.lang.Override
	public MultichoiceQuestion introduction(java.lang.String introduction) {
		setIntroduction(introduction);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public MultichoiceQuestion answerIndex(java.lang.Integer answerIndex) {
		setAnswerIndex(answerIndex);
		return this;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	@java.lang.Override
	public MultichoiceQuestion answerIndices(java.util.List<java.lang.Integer> answerIndices) {
		setAnswerIndices(answerIndices);
		return this;
	}
	
	/**
	 * when available, string value that was put as an answer
	 */
	@java.lang.Override
	public MultichoiceQuestion answeredStringValue(java.lang.String answeredStringValue) {
		setAnsweredStringValue(answeredStringValue);
		return this;
	}
	
	/**
	 * when available, whether the user chose to mark this question as not applicable
	 */
	@java.lang.Override
	public MultichoiceQuestion answerNotApplicable(java.lang.Boolean answerNotApplicable) {
		setAnswerNotApplicable(answerNotApplicable);
		return this;
	}
	
	/**
	 * when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.
	 */
	@java.lang.Override
	public MultichoiceQuestion otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	/**
	 * indicates that the answer is not compulsory
	 */
	@java.lang.Override
	public MultichoiceQuestion optional(java.lang.Boolean optional) {
		setOptional(optional);
		return this;
	}
	
	/**
	 * indicates that the question is created as a part of custom question
	 */
	@java.lang.Override
	public MultichoiceQuestion custom(java.lang.Boolean custom) {
		setCustom(custom);
		return this;
	}
	
	/**
	 * indicates that the question is custom question and is a part of open survey, therefore it can&#x27;t be edited
	 */
	@java.lang.Override
	public MultichoiceQuestion locked(java.lang.Boolean locked) {
		setLocked(locked);
		return this;
	}
	
	/**
	 * array of answer options for multichoice question
	 */
	public MultichoiceQuestion options(java.util.List<java.lang.String> options) {
		setOptions(options);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "array of answer options for multichoice question")
	@com.fasterxml.jackson.annotation.JsonProperty("options")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<java.lang.String> getOptions() {
		return this.options;
	}
	public void setOptions(java.util.List<java.lang.String> options) {
		this.options = options;
	}
	public void addOption(java.lang.String option) {
		if (this.options == null) {
			this.options = new java.util.ArrayList<java.lang.String>();
		}
		this.options.add(option);
	}
	
	/**
	 * in case of multichoice question flag notifies that participant can provide answer which is not in the initial list of options
	 */
	public MultichoiceQuestion allowOtherAnswer(boolean allowOtherAnswer) {
		setAllowOtherAnswer(allowOtherAnswer);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "in case of multichoice question flag notifies that participant can provide answer which is not in the initial list of options")
	@com.fasterxml.jackson.annotation.JsonProperty("allowOtherAnswer")
	@javax.validation.constraints.NotNull
	public boolean isAllowOtherAnswer() {
		return this.allowOtherAnswer;
	}
	public void setAllowOtherAnswer(boolean allowOtherAnswer) {
		this.allowOtherAnswer = allowOtherAnswer;
	}
	
	/**
	 */
	public MultichoiceQuestion multichoiceType(com.example.model.MultichoiceQuestion.MultichoiceTypeEnum multichoiceType) {
		setMultichoiceType(multichoiceType);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("multichoiceType")
	@javax.validation.constraints.NotNull
	public com.example.model.MultichoiceQuestion.MultichoiceTypeEnum getMultichoiceType() {
		return this.multichoiceType;
	}
	public void setMultichoiceType(com.example.model.MultichoiceQuestion.MultichoiceTypeEnum multichoiceType) {
		this.multichoiceType = multichoiceType;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		MultichoiceQuestion multichoiceQuestion = (MultichoiceQuestion) o;
		return java.util.Objects.equals(this.options, multichoiceQuestion.options) &&
				java.util.Objects.equals(this.allowOtherAnswer, multichoiceQuestion.allowOtherAnswer) &&
				java.util.Objects.equals(this.multichoiceType, multichoiceQuestion.multichoiceType);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.options, this.allowOtherAnswer, this.multichoiceType);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class MultichoiceQuestion {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    options: ").append(toIndentedString(this.options)).append("\n");
		sb.append("    allowOtherAnswer: ").append(toIndentedString(this.allowOtherAnswer)).append("\n");
		sb.append("    multichoiceType: ").append(toIndentedString(this.multichoiceType)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
