package com.example.model;

/**
 * Information about a participation in a survey. Represents a Participation in our database model.
 */
@io.swagger.annotations.ApiModel(value = "Participation", description = "Information about a participation in a survey. Represents a Participation in our database model.")
@javax.xml.bind.annotation.XmlRootElement(name = "Participation")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Participation implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "StatusEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum StatusEnum {
		@javax.xml.bind.annotation.XmlEnumValue("ADDED") ADDED("ADDED"), 
		@javax.xml.bind.annotation.XmlEnumValue("INVITED") INVITED("INVITED"), 
		@javax.xml.bind.annotation.XmlEnumValue("COMPLETED") COMPLETED("COMPLETED");
		
		private java.lang.String value;
		
		StatusEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static StatusEnum fromValue(String v) {
			for (StatusEnum b : StatusEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	private java.util.UUID id = null;
	private com.example.model.Participant participant = null;
	private java.time.OffsetDateTime whenLastInvited = null;
	private com.example.model.Participation.StatusEnum status = null;
	
	/**
	 * The participation ID
	 */
	public Participation id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The participation ID")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 * Information about a person who can be a participant in a survey. Represents a Person with a Role of Participant in our database model.
	 */
	public Participation participant(com.example.model.Participant participant) {
		setParticipant(participant);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Information about a person who can be a participant in a survey. Represents a Person with a Role of Participant in our database model.")
	@com.fasterxml.jackson.annotation.JsonProperty("participant")
	@javax.validation.Valid
	public com.example.model.Participant getParticipant() {
		return this.participant;
	}
	public void setParticipant(com.example.model.Participant participant) {
		this.participant = participant;
	}
	
	/**
	 */
	public Participation whenLastInvited(java.time.OffsetDateTime whenLastInvited) {
		setWhenLastInvited(whenLastInvited);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenLastInvited")
	public java.time.OffsetDateTime getWhenLastInvited() {
		return this.whenLastInvited;
	}
	public void setWhenLastInvited(java.time.OffsetDateTime whenLastInvited) {
		this.whenLastInvited = whenLastInvited;
	}
	
	/**
	 */
	public Participation status(com.example.model.Participation.StatusEnum status) {
		setStatus(status);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("status")
	@javax.validation.constraints.NotNull
	public com.example.model.Participation.StatusEnum getStatus() {
		return this.status;
	}
	public void setStatus(com.example.model.Participation.StatusEnum status) {
		this.status = status;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		Participation participation = (Participation) o;
		return java.util.Objects.equals(this.id, participation.id) &&
				java.util.Objects.equals(this.participant, participation.participant) &&
				java.util.Objects.equals(this.whenLastInvited, participation.whenLastInvited) &&
				java.util.Objects.equals(this.status, participation.status);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.participant, this.whenLastInvited, this.status);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Participation {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    participant: ").append(toIndentedString(this.participant)).append("\n");
		sb.append("    whenLastInvited: ").append(toIndentedString(this.whenLastInvited)).append("\n");
		sb.append("    status: ").append(toIndentedString(this.status)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
