package com.example.model;

@io.swagger.annotations.ApiModel(value = "Question", discriminator="type")
@javax.xml.bind.annotation.XmlRootElement(name = "Question")
@com.fasterxml.jackson.annotation.JsonTypeInfo(use=com.fasterxml.jackson.annotation.JsonTypeInfo.Id.NAME, include=com.fasterxml.jackson.annotation.JsonTypeInfo.As.PROPERTY, property="type")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.ScaleQuestion.class, name = "scale"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.MultichoiceQuestion.class, name = "multi"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.MatrixQuestion.class, name = "matrix"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.MatrixSubQuestion.class, name = "matrix-sub"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.FreeTextQuestion.class, name = "free-text"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class Question implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String title = null;
	private java.lang.String subtitle = null;
	private java.lang.String introduction = null;
	private java.lang.Integer answerIndex = null;
	private java.util.List<java.lang.Integer> answerIndices = null;
	private java.lang.String answeredStringValue = null;
	private java.lang.Boolean answerNotApplicable = null;
	private java.lang.String otherTitle = null;
	private java.lang.Boolean optional = null;
	private java.lang.Boolean custom = null;
	private java.lang.Boolean locked = null;
	
	/**
	 * question id
	 */
	public Question id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "question id")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 * question title, e.g. How long have you worked for this organisation?
	 */
	public Question title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "question title, e.g. How long have you worked for this organisation?")
	@com.fasterxml.jackson.annotation.JsonProperty("title")
	@javax.validation.constraints.NotNull
	public java.lang.String getTitle() {
		return this.title;
	}
	public void setTitle(java.lang.String title) {
		this.title = title;
	}
	
	/**
	 * Extra text to go underneath the title to clarify something about the question.
	 */
	public Question subtitle(java.lang.String subtitle) {
		setSubtitle(subtitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Extra text to go underneath the title to clarify something about the question.")
	@com.fasterxml.jackson.annotation.JsonProperty("subtitle")
	public java.lang.String getSubtitle() {
		return this.subtitle;
	}
	public void setSubtitle(java.lang.String subtitle) {
		this.subtitle = subtitle;
	}
	
	/**
	 * Introductory text to the question.
	 */
	public Question introduction(java.lang.String introduction) {
		setIntroduction(introduction);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "Introductory text to the question.")
	@com.fasterxml.jackson.annotation.JsonProperty("introduction")
	public java.lang.String getIntroduction() {
		return this.introduction;
	}
	public void setIntroduction(java.lang.String introduction) {
		this.introduction = introduction;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	public Question answerIndex(java.lang.Integer answerIndex) {
		setAnswerIndex(answerIndex);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "index of answer option in options array/within min-max range")
	@com.fasterxml.jackson.annotation.JsonProperty("answerIndex")
	public java.lang.Integer getAnswerIndex() {
		return this.answerIndex;
	}
	public void setAnswerIndex(java.lang.Integer answerIndex) {
		this.answerIndex = answerIndex;
	}
	
	/**
	 * index of answer option in options array/within min-max range
	 */
	public Question answerIndices(java.util.List<java.lang.Integer> answerIndices) {
		setAnswerIndices(answerIndices);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "index of answer option in options array/within min-max range")
	@com.fasterxml.jackson.annotation.JsonProperty("answerIndices")
	@javax.validation.Valid
	public java.util.List<java.lang.Integer> getAnswerIndices() {
		return this.answerIndices;
	}
	public void setAnswerIndices(java.util.List<java.lang.Integer> answerIndices) {
		this.answerIndices = answerIndices;
	}
	public void addAnswerIndex(int answerIndex) {
		if (this.answerIndices == null) {
			this.answerIndices = new java.util.ArrayList<java.lang.Integer>();
		}
		this.answerIndices.add(answerIndex);
	}
	
	/**
	 * when available, string value that was put as an answer
	 */
	public Question answeredStringValue(java.lang.String answeredStringValue) {
		setAnsweredStringValue(answeredStringValue);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when available, string value that was put as an answer")
	@com.fasterxml.jackson.annotation.JsonProperty("answeredStringValue")
	public java.lang.String getAnsweredStringValue() {
		return this.answeredStringValue;
	}
	public void setAnsweredStringValue(java.lang.String answeredStringValue) {
		this.answeredStringValue = answeredStringValue;
	}
	
	/**
	 * when available, whether the user chose to mark this question as not applicable
	 */
	public Question answerNotApplicable(java.lang.Boolean answerNotApplicable) {
		setAnswerNotApplicable(answerNotApplicable);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when available, whether the user chose to mark this question as not applicable")
	@com.fasterxml.jackson.annotation.JsonProperty("answerNotApplicable")
	public java.lang.Boolean getAnswerNotApplicable() {
		return this.answerNotApplicable;
	}
	public void setAnswerNotApplicable(java.lang.Boolean answerNotApplicable) {
		this.answerNotApplicable = answerNotApplicable;
	}
	
	/**
	 * when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.
	 */
	public Question otherTitle(java.lang.String otherTitle) {
		setOtherTitle(otherTitle);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "when matrix sub-question is set to requiresOtherTitle and participant has answered the question and provided other title, it will be set here.")
	@com.fasterxml.jackson.annotation.JsonProperty("otherTitle")
	public java.lang.String getOtherTitle() {
		return this.otherTitle;
	}
	public void setOtherTitle(java.lang.String otherTitle) {
		this.otherTitle = otherTitle;
	}
	
	/**
	 * indicates that the answer is not compulsory
	 */
	public Question optional(java.lang.Boolean optional) {
		setOptional(optional);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the answer is not compulsory")
	@com.fasterxml.jackson.annotation.JsonProperty("optional")
	public java.lang.Boolean getOptional() {
		return this.optional;
	}
	public void setOptional(java.lang.Boolean optional) {
		this.optional = optional;
	}
	
	/**
	 * indicates that the question is created as a part of custom question
	 */
	public Question custom(java.lang.Boolean custom) {
		setCustom(custom);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the question is created as a part of custom question")
	@com.fasterxml.jackson.annotation.JsonProperty("custom")
	public java.lang.Boolean getCustom() {
		return this.custom;
	}
	public void setCustom(java.lang.Boolean custom) {
		this.custom = custom;
	}
	
	/**
	 * indicates that the question is custom question and is a part of open survey, therefore it can&#x27;t be edited
	 */
	public Question locked(java.lang.Boolean locked) {
		setLocked(locked);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "indicates that the question is custom question and is a part of open survey, therefore it can't be edited")
	@com.fasterxml.jackson.annotation.JsonProperty("locked")
	public java.lang.Boolean getLocked() {
		return this.locked;
	}
	public void setLocked(java.lang.Boolean locked) {
		this.locked = locked;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		Question question = (Question) o;
		return java.util.Objects.equals(this.id, question.id) &&
				java.util.Objects.equals(this.title, question.title) &&
				java.util.Objects.equals(this.subtitle, question.subtitle) &&
				java.util.Objects.equals(this.introduction, question.introduction) &&
				java.util.Objects.equals(this.answerIndex, question.answerIndex) &&
				java.util.Objects.equals(this.answerIndices, question.answerIndices) &&
				java.util.Objects.equals(this.answeredStringValue, question.answeredStringValue) &&
				java.util.Objects.equals(this.answerNotApplicable, question.answerNotApplicable) &&
				java.util.Objects.equals(this.otherTitle, question.otherTitle) &&
				java.util.Objects.equals(this.optional, question.optional) &&
				java.util.Objects.equals(this.custom, question.custom) &&
				java.util.Objects.equals(this.locked, question.locked);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.title, this.subtitle, this.introduction, this.answerIndex, this.answerIndices, this.answeredStringValue, this.answerNotApplicable, this.otherTitle, this.optional, this.custom, this.locked);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class Question {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
		sb.append("    subtitle: ").append(toIndentedString(this.subtitle)).append("\n");
		sb.append("    introduction: ").append(toIndentedString(this.introduction)).append("\n");
		sb.append("    answerIndex: ").append(toIndentedString(this.answerIndex)).append("\n");
		sb.append("    answerIndices: ").append(toIndentedString(this.answerIndices)).append("\n");
		sb.append("    answeredStringValue: ").append(toIndentedString(this.answeredStringValue)).append("\n");
		sb.append("    answerNotApplicable: ").append(toIndentedString(this.answerNotApplicable)).append("\n");
		sb.append("    otherTitle: ").append(toIndentedString(this.otherTitle)).append("\n");
		sb.append("    optional: ").append(toIndentedString(this.optional)).append("\n");
		sb.append("    custom: ").append(toIndentedString(this.custom)).append("\n");
		sb.append("    locked: ").append(toIndentedString(this.locked)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
