package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyDetails")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyDetails")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyDetails extends com.example.model.SurveySummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.List<com.example.model.SurveySection> editableSections = new java.util.ArrayList<com.example.model.SurveySection>();
	private java.net.URL participantUrl = null;
	private java.lang.String contactName = null;
	private java.lang.String contactEmail = null;
	private java.lang.String riskContactEmail = null;
	private java.lang.String defaultRiskContactEmail = null;
	private java.lang.String invitationMessage = null;
	private java.lang.String defaultInvitationMessage = null;
	private java.lang.String welcome = null;
	private java.lang.String defaultWelcome = null;
	private java.lang.String thanksMessage = null;
	private java.lang.String defaultThanksMessage = null;
	private java.lang.String riskThanksMessage = null;
	private java.lang.String defaultRiskThanksMessage = null;
	private java.lang.String privacyStatement = null;
	private java.lang.String defaultPrivacyStatement = null;
	private java.lang.Boolean removeCompletedParticipations = null;
	private boolean locked = false;
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	/**
	 * A survey template that can be used to create a survey
	 */
	@java.lang.Override
	public SurveyDetails template(com.example.model.SurveyTemplate template) {
		setTemplate(template);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails status(com.example.model.SurveySummary.StatusEnum status) {
		setStatus(status);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails lastModified(java.time.OffsetDateTime lastModified) {
		setLastModified(lastModified);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails archived(boolean archived) {
		setArchived(archived);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails participants(com.example.model.SurveySummary.Participants participants) {
		setParticipants(participants);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails scheduling(com.example.model.Scheduling scheduling) {
		setScheduling(scheduling);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails whenOpen(java.time.OffsetDateTime whenOpen) {
		setWhenOpen(whenOpen);
		return this;
	}
	
	/**
	 */
	@java.lang.Override
	public SurveyDetails whenClosed(java.time.OffsetDateTime whenClosed) {
		setWhenClosed(whenClosed);
		return this;
	}
	
	/**
	 */
	public SurveyDetails editableSections(java.util.List<com.example.model.SurveySection> editableSections) {
		setEditableSections(editableSections);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("editableSections")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.SurveySection> getEditableSections() {
		return this.editableSections;
	}
	public void setEditableSections(java.util.List<com.example.model.SurveySection> editableSections) {
		this.editableSections = editableSections;
	}
	public void addEditableSection(com.example.model.SurveySection editableSection) {
		if (this.editableSections == null) {
			this.editableSections = new java.util.ArrayList<com.example.model.SurveySection>();
		}
		this.editableSections.add(editableSection);
	}
	
	/**
	 * The URL that anonymous participants can visit to participate in the survey.
	 */
	public SurveyDetails participantUrl(java.net.URL participantUrl) {
		setParticipantUrl(participantUrl);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The URL that anonymous participants can visit to participate in the survey.")
	@com.fasterxml.jackson.annotation.JsonProperty("participantUrl")
	public java.net.URL getParticipantUrl() {
		return this.participantUrl;
	}
	public void setParticipantUrl(java.net.URL participantUrl) {
		this.participantUrl = participantUrl;
	}
	
	/**
	 */
	public SurveyDetails contactName(java.lang.String contactName) {
		setContactName(contactName);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contactName")
	public java.lang.String getContactName() {
		return this.contactName;
	}
	public void setContactName(java.lang.String contactName) {
		this.contactName = contactName;
	}
	
	/**
	 */
	public SurveyDetails contactEmail(java.lang.String contactEmail) {
		setContactEmail(contactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("contactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getContactEmail() {
		return this.contactEmail;
	}
	public void setContactEmail(java.lang.String contactEmail) {
		this.contactEmail = contactEmail;
	}
	
	/**
	 * This property is only populated if the currently authenticated user is a super-admin.
	 */
	public SurveyDetails riskContactEmail(java.lang.String riskContactEmail) {
		setRiskContactEmail(riskContactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "This property is only populated if the currently authenticated user is a super-admin.")
	@com.fasterxml.jackson.annotation.JsonProperty("riskContactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getRiskContactEmail() {
		return this.riskContactEmail;
	}
	public void setRiskContactEmail(java.lang.String riskContactEmail) {
		this.riskContactEmail = riskContactEmail;
	}
	
	/**
	 * The default risk contact email that will be used if one is not set.
	 */
	public SurveyDetails defaultRiskContactEmail(java.lang.String defaultRiskContactEmail) {
		setDefaultRiskContactEmail(defaultRiskContactEmail);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "The default risk contact email that will be used if one is not set.")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultRiskContactEmail")
	@javax.validation.constraints.Email
	public java.lang.String getDefaultRiskContactEmail() {
		return this.defaultRiskContactEmail;
	}
	public void setDefaultRiskContactEmail(java.lang.String defaultRiskContactEmail) {
		this.defaultRiskContactEmail = defaultRiskContactEmail;
	}
	
	/**
	 */
	public SurveyDetails invitationMessage(java.lang.String invitationMessage) {
		setInvitationMessage(invitationMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("invitationMessage")
	public java.lang.String getInvitationMessage() {
		return this.invitationMessage;
	}
	public void setInvitationMessage(java.lang.String invitationMessage) {
		this.invitationMessage = invitationMessage;
	}
	
	/**
	 */
	public SurveyDetails defaultInvitationMessage(java.lang.String defaultInvitationMessage) {
		setDefaultInvitationMessage(defaultInvitationMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultInvitationMessage")
	public java.lang.String getDefaultInvitationMessage() {
		return this.defaultInvitationMessage;
	}
	public void setDefaultInvitationMessage(java.lang.String defaultInvitationMessage) {
		this.defaultInvitationMessage = defaultInvitationMessage;
	}
	
	/**
	 */
	public SurveyDetails welcome(java.lang.String welcome) {
		setWelcome(welcome);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("welcome")
	public java.lang.String getWelcome() {
		return this.welcome;
	}
	public void setWelcome(java.lang.String welcome) {
		this.welcome = welcome;
	}
	
	/**
	 */
	public SurveyDetails defaultWelcome(java.lang.String defaultWelcome) {
		setDefaultWelcome(defaultWelcome);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultWelcome")
	public java.lang.String getDefaultWelcome() {
		return this.defaultWelcome;
	}
	public void setDefaultWelcome(java.lang.String defaultWelcome) {
		this.defaultWelcome = defaultWelcome;
	}
	
	/**
	 */
	public SurveyDetails thanksMessage(java.lang.String thanksMessage) {
		setThanksMessage(thanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("thanksMessage")
	public java.lang.String getThanksMessage() {
		return this.thanksMessage;
	}
	public void setThanksMessage(java.lang.String thanksMessage) {
		this.thanksMessage = thanksMessage;
	}
	
	/**
	 */
	public SurveyDetails defaultThanksMessage(java.lang.String defaultThanksMessage) {
		setDefaultThanksMessage(defaultThanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultThanksMessage")
	public java.lang.String getDefaultThanksMessage() {
		return this.defaultThanksMessage;
	}
	public void setDefaultThanksMessage(java.lang.String defaultThanksMessage) {
		this.defaultThanksMessage = defaultThanksMessage;
	}
	
	/**
	 */
	public SurveyDetails riskThanksMessage(java.lang.String riskThanksMessage) {
		setRiskThanksMessage(riskThanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("riskThanksMessage")
	public java.lang.String getRiskThanksMessage() {
		return this.riskThanksMessage;
	}
	public void setRiskThanksMessage(java.lang.String riskThanksMessage) {
		this.riskThanksMessage = riskThanksMessage;
	}
	
	/**
	 */
	public SurveyDetails defaultRiskThanksMessage(java.lang.String defaultRiskThanksMessage) {
		setDefaultRiskThanksMessage(defaultRiskThanksMessage);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultRiskThanksMessage")
	public java.lang.String getDefaultRiskThanksMessage() {
		return this.defaultRiskThanksMessage;
	}
	public void setDefaultRiskThanksMessage(java.lang.String defaultRiskThanksMessage) {
		this.defaultRiskThanksMessage = defaultRiskThanksMessage;
	}
	
	/**
	 */
	public SurveyDetails privacyStatement(java.lang.String privacyStatement) {
		setPrivacyStatement(privacyStatement);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("privacyStatement")
	public java.lang.String getPrivacyStatement() {
		return this.privacyStatement;
	}
	public void setPrivacyStatement(java.lang.String privacyStatement) {
		this.privacyStatement = privacyStatement;
	}
	
	/**
	 */
	public SurveyDetails defaultPrivacyStatement(java.lang.String defaultPrivacyStatement) {
		setDefaultPrivacyStatement(defaultPrivacyStatement);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("defaultPrivacyStatement")
	public java.lang.String getDefaultPrivacyStatement() {
		return this.defaultPrivacyStatement;
	}
	public void setDefaultPrivacyStatement(java.lang.String defaultPrivacyStatement) {
		this.defaultPrivacyStatement = defaultPrivacyStatement;
	}
	
	/**
	 * if current user has permission to remove completed participations from non-completed survey
	 */
	public SurveyDetails removeCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		setRemoveCompletedParticipations(removeCompletedParticipations);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "if current user has permission to remove completed participations from non-completed survey")
	@com.fasterxml.jackson.annotation.JsonProperty("removeCompletedParticipations")
	public java.lang.Boolean getRemoveCompletedParticipations() {
		return this.removeCompletedParticipations;
	}
	public void setRemoveCompletedParticipations(java.lang.Boolean removeCompletedParticipations) {
		this.removeCompletedParticipations = removeCompletedParticipations;
	}
	
	/**
	 * Is the survey locked for the purposes of editing or changing participants&gt;
	 */
	public SurveyDetails locked(boolean locked) {
		setLocked(locked);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "Is the survey locked for the purposes of editing or changing participants>")
	@com.fasterxml.jackson.annotation.JsonProperty("locked")
	@javax.validation.constraints.NotNull
	public boolean isLocked() {
		return this.locked;
	}
	public void setLocked(boolean locked) {
		this.locked = locked;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		if (!super.equals(o)) {
			return false;
		}
		SurveyDetails surveyDetails = (SurveyDetails) o;
		return java.util.Objects.equals(this.editableSections, surveyDetails.editableSections) &&
				java.util.Objects.equals(this.participantUrl, surveyDetails.participantUrl) &&
				java.util.Objects.equals(this.contactName, surveyDetails.contactName) &&
				java.util.Objects.equals(this.contactEmail, surveyDetails.contactEmail) &&
				java.util.Objects.equals(this.riskContactEmail, surveyDetails.riskContactEmail) &&
				java.util.Objects.equals(this.defaultRiskContactEmail, surveyDetails.defaultRiskContactEmail) &&
				java.util.Objects.equals(this.invitationMessage, surveyDetails.invitationMessage) &&
				java.util.Objects.equals(this.defaultInvitationMessage, surveyDetails.defaultInvitationMessage) &&
				java.util.Objects.equals(this.welcome, surveyDetails.welcome) &&
				java.util.Objects.equals(this.defaultWelcome, surveyDetails.defaultWelcome) &&
				java.util.Objects.equals(this.thanksMessage, surveyDetails.thanksMessage) &&
				java.util.Objects.equals(this.defaultThanksMessage, surveyDetails.defaultThanksMessage) &&
				java.util.Objects.equals(this.riskThanksMessage, surveyDetails.riskThanksMessage) &&
				java.util.Objects.equals(this.defaultRiskThanksMessage, surveyDetails.defaultRiskThanksMessage) &&
				java.util.Objects.equals(this.privacyStatement, surveyDetails.privacyStatement) &&
				java.util.Objects.equals(this.defaultPrivacyStatement, surveyDetails.defaultPrivacyStatement) &&
				java.util.Objects.equals(this.removeCompletedParticipations, surveyDetails.removeCompletedParticipations) &&
				java.util.Objects.equals(this.locked, surveyDetails.locked);
	}
	
	@Override
	public int hashCode() {
		return 31 * super.hashCode() + java.util.Objects.hash(this.editableSections, this.participantUrl, this.contactName, this.contactEmail, this.riskContactEmail, this.defaultRiskContactEmail, this.invitationMessage, this.defaultInvitationMessage, this.welcome, this.defaultWelcome, this.thanksMessage, this.defaultThanksMessage, this.riskThanksMessage, this.defaultRiskThanksMessage, this.privacyStatement, this.defaultPrivacyStatement, this.removeCompletedParticipations, this.locked);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyDetails {\n");
		sb.append("    ").append(toIndentedString(super.toString())).append("\n");
		sb.append("    editableSections: ").append(toIndentedString(this.editableSections)).append("\n");
		sb.append("    participantUrl: ").append(toIndentedString(this.participantUrl)).append("\n");
		sb.append("    contactName: ").append(toIndentedString(this.contactName)).append("\n");
		sb.append("    contactEmail: ").append(toIndentedString(this.contactEmail)).append("\n");
		sb.append("    riskContactEmail: ").append(toIndentedString(this.riskContactEmail)).append("\n");
		sb.append("    defaultRiskContactEmail: ").append(toIndentedString(this.defaultRiskContactEmail)).append("\n");
		sb.append("    invitationMessage: ").append(toIndentedString(this.invitationMessage)).append("\n");
		sb.append("    defaultInvitationMessage: ").append(toIndentedString(this.defaultInvitationMessage)).append("\n");
		sb.append("    welcome: ").append(toIndentedString(this.welcome)).append("\n");
		sb.append("    defaultWelcome: ").append(toIndentedString(this.defaultWelcome)).append("\n");
		sb.append("    thanksMessage: ").append(toIndentedString(this.thanksMessage)).append("\n");
		sb.append("    defaultThanksMessage: ").append(toIndentedString(this.defaultThanksMessage)).append("\n");
		sb.append("    riskThanksMessage: ").append(toIndentedString(this.riskThanksMessage)).append("\n");
		sb.append("    defaultRiskThanksMessage: ").append(toIndentedString(this.defaultRiskThanksMessage)).append("\n");
		sb.append("    privacyStatement: ").append(toIndentedString(this.privacyStatement)).append("\n");
		sb.append("    defaultPrivacyStatement: ").append(toIndentedString(this.defaultPrivacyStatement)).append("\n");
		sb.append("    removeCompletedParticipations: ").append(toIndentedString(this.removeCompletedParticipations)).append("\n");
		sb.append("    locked: ").append(toIndentedString(this.locked)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
