package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveyReportArea", discriminator="areaType")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveyReportArea")
@com.fasterxml.jackson.annotation.JsonTypeInfo(use=com.fasterxml.jackson.annotation.JsonTypeInfo.Id.NAME, include=com.fasterxml.jackson.annotation.JsonTypeInfo.As.PROPERTY, property="areaType")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.SurveyReportDataArea.class, name = "data"),
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.SurveyReportAspectsArea.class, name = "aspects"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveyReportArea implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private java.lang.String description = null;
	private java.math.BigDecimal score = new java.math.BigDecimal("0");
	private java.lang.String minLabel = null;
	private java.lang.String midLabel = null;
	private java.lang.String maxLabel = null;
	private com.example.model.Article article = null;
	private java.lang.String analysis = null;
	
	/**
	 */
	public SurveyReportArea id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public SurveyReportArea name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 */
	public SurveyReportArea description(java.lang.String description) {
		setDescription(description);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("description")
	public java.lang.String getDescription() {
		return this.description;
	}
	public void setDescription(java.lang.String description) {
		this.description = description;
	}
	
	/**
	 * Score between 0.0 and 1.0 representing the overall score of this area for the main series of data.
	 */
	public SurveyReportArea score(java.math.BigDecimal score) {
		setScore(score);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "Score between 0.0 and 1.0 representing the overall score of this area for the main series of data.")
	@com.fasterxml.jackson.annotation.JsonProperty("score")
	@javax.validation.constraints.NotNull
	public java.math.BigDecimal getScore() {
		return this.score;
	}
	public void setScore(java.math.BigDecimal score) {
		this.score = score;
	}
	
	/**
	 */
	public SurveyReportArea minLabel(java.lang.String minLabel) {
		setMinLabel(minLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("minLabel")
	public java.lang.String getMinLabel() {
		return this.minLabel;
	}
	public void setMinLabel(java.lang.String minLabel) {
		this.minLabel = minLabel;
	}
	
	/**
	 */
	public SurveyReportArea midLabel(java.lang.String midLabel) {
		setMidLabel(midLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("midLabel")
	public java.lang.String getMidLabel() {
		return this.midLabel;
	}
	public void setMidLabel(java.lang.String midLabel) {
		this.midLabel = midLabel;
	}
	
	/**
	 */
	public SurveyReportArea maxLabel(java.lang.String maxLabel) {
		setMaxLabel(maxLabel);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("maxLabel")
	public java.lang.String getMaxLabel() {
		return this.maxLabel;
	}
	public void setMaxLabel(java.lang.String maxLabel) {
		this.maxLabel = maxLabel;
	}
	
	/**
	 * An article from the library.
	 */
	public SurveyReportArea article(com.example.model.Article article) {
		setArticle(article);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "An article from the library.")
	@com.fasterxml.jackson.annotation.JsonProperty("article")
	@javax.validation.Valid
	public com.example.model.Article getArticle() {
		return this.article;
	}
	public void setArticle(com.example.model.Article article) {
		this.article = article;
	}
	
	/**
	 * analysis for the report are from Umbrella
	 */
	public SurveyReportArea analysis(java.lang.String analysis) {
		setAnalysis(analysis);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "analysis for the report are from Umbrella")
	@com.fasterxml.jackson.annotation.JsonProperty("analysis")
	public java.lang.String getAnalysis() {
		return this.analysis;
	}
	public void setAnalysis(java.lang.String analysis) {
		this.analysis = analysis;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveyReportArea surveyReportArea = (SurveyReportArea) o;
		return java.util.Objects.equals(this.id, surveyReportArea.id) &&
				java.util.Objects.equals(this.name, surveyReportArea.name) &&
				java.util.Objects.equals(this.description, surveyReportArea.description) &&
				java.util.Objects.equals(this.score, surveyReportArea.score) &&
				java.util.Objects.equals(this.minLabel, surveyReportArea.minLabel) &&
				java.util.Objects.equals(this.midLabel, surveyReportArea.midLabel) &&
				java.util.Objects.equals(this.maxLabel, surveyReportArea.maxLabel) &&
				java.util.Objects.equals(this.article, surveyReportArea.article) &&
				java.util.Objects.equals(this.analysis, surveyReportArea.analysis);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.description, this.score, this.minLabel, this.midLabel, this.maxLabel, this.article, this.analysis);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveyReportArea {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    description: ").append(toIndentedString(this.description)).append("\n");
		sb.append("    score: ").append(toIndentedString(this.score)).append("\n");
		sb.append("    minLabel: ").append(toIndentedString(this.minLabel)).append("\n");
		sb.append("    midLabel: ").append(toIndentedString(this.midLabel)).append("\n");
		sb.append("    maxLabel: ").append(toIndentedString(this.maxLabel)).append("\n");
		sb.append("    article: ").append(toIndentedString(this.article)).append("\n");
		sb.append("    analysis: ").append(toIndentedString(this.analysis)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
