package com.example.model;

/**
 * A customisable section of a survey
 */
@io.swagger.annotations.ApiModel(value = "SurveySection", description = "A customisable section of a survey")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveySection")
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveySection implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	private java.util.UUID id = null;
	private java.lang.String title = null;
	private java.util.List<com.example.model.Question> questions = new java.util.ArrayList<com.example.model.Question>();
	private java.util.List<com.example.model.Question> availableQuestions = new java.util.ArrayList<com.example.model.Question>();
	
	/**
	 */
	public SurveySection id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public SurveySection title(java.lang.String title) {
		setTitle(title);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("title")
	@javax.validation.constraints.NotNull
	public java.lang.String getTitle() {
		return this.title;
	}
	public void setTitle(java.lang.String title) {
		this.title = title;
	}
	
	/**
	 * The questions that have been selected for this section of the survey.
	 */
	public SurveySection questions(java.util.List<com.example.model.Question> questions) {
		setQuestions(questions);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "The questions that have been selected for this section of the survey.")
	@com.fasterxml.jackson.annotation.JsonProperty("questions")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.Question> getQuestions() {
		return this.questions;
	}
	public void setQuestions(java.util.List<com.example.model.Question> questions) {
		this.questions = questions;
	}
	public void addQuestion(com.example.model.Question question) {
		if (this.questions == null) {
			this.questions = new java.util.ArrayList<com.example.model.Question>();
		}
		this.questions.add(question);
	}
	
	/**
	 * Questions that may be added to the survey section.
	 */
	public SurveySection availableQuestions(java.util.List<com.example.model.Question> availableQuestions) {
		setAvailableQuestions(availableQuestions);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "Questions that may be added to the survey section.")
	@com.fasterxml.jackson.annotation.JsonProperty("availableQuestions")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public java.util.List<com.example.model.Question> getAvailableQuestions() {
		return this.availableQuestions;
	}
	public void setAvailableQuestions(java.util.List<com.example.model.Question> availableQuestions) {
		this.availableQuestions = availableQuestions;
	}
	public void addAvailableQuestion(com.example.model.Question availableQuestion) {
		if (this.availableQuestions == null) {
			this.availableQuestions = new java.util.ArrayList<com.example.model.Question>();
		}
		this.availableQuestions.add(availableQuestion);
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveySection surveySection = (SurveySection) o;
		return java.util.Objects.equals(this.id, surveySection.id) &&
				java.util.Objects.equals(this.title, surveySection.title) &&
				java.util.Objects.equals(this.questions, surveySection.questions) &&
				java.util.Objects.equals(this.availableQuestions, surveySection.availableQuestions);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.title, this.questions, this.availableQuestions);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveySection {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    title: ").append(toIndentedString(this.title)).append("\n");
		sb.append("    questions: ").append(toIndentedString(this.questions)).append("\n");
		sb.append("    availableQuestions: ").append(toIndentedString(this.availableQuestions)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
