package com.example.model;

@io.swagger.annotations.ApiModel(value = "SurveySummary")
@javax.xml.bind.annotation.XmlRootElement(name = "SurveySummary")
@com.fasterxml.jackson.annotation.JsonSubTypes({
	@com.fasterxml.jackson.annotation.JsonSubTypes.Type(value = com.example.model.SurveyDetails.class, name = "SurveyDetails"),
})
@javax.annotation.Generated(value = "@openapi-generator-plus/java-cxf-spring-server-generator", date = "2020-12-09T09:45:01.570Z")
public class SurveySummary implements java.io.Serializable {

	private static final long serialVersionUID = 1L;
	@javax.xml.bind.annotation.XmlType(name = "StatusEnum")
	@javax.xml.bind.annotation.XmlEnum(java.lang.String.class)
	public enum StatusEnum {
		@javax.xml.bind.annotation.XmlEnumValue("DRAFT") DRAFT("DRAFT"), 
		@javax.xml.bind.annotation.XmlEnumValue("READY") READY("READY"), 
		@javax.xml.bind.annotation.XmlEnumValue("SCHEDULED") SCHEDULED("SCHEDULED"), 
		@javax.xml.bind.annotation.XmlEnumValue("OPEN") OPEN("OPEN"), 
		@javax.xml.bind.annotation.XmlEnumValue("CLOSED") CLOSED("CLOSED");
		
		private java.lang.String value;
		
		StatusEnum(java.lang.String v) {
			value = v;
		}
		
		@com.fasterxml.jackson.annotation.JsonValue
		public String value() {
			return value;
		}
		
		@Override
		public String toString() {
			return String.valueOf(value);
		}
		
		public static StatusEnum fromValue(String v) {
			for (StatusEnum b : StatusEnum.values()) {
				if (String.valueOf(b.value).equals(v)) {
					return b;
				}
			}
			return null;
		}
	}
	
	@io.swagger.annotations.ApiModel(value = "")
	public static class Participants implements java.io.Serializable {
	
		private static final long serialVersionUID = 1L;
		private int totalCount = 0;
		private int completedCount = 0;
		private int inProgressCount = 0;
		private int notStartedCount = 0;
		
		/**
		 */
		public Participants totalCount(int totalCount) {
			setTotalCount(totalCount);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("totalCount")
		@javax.validation.constraints.NotNull
		public int getTotalCount() {
			return this.totalCount;
		}
		public void setTotalCount(int totalCount) {
			this.totalCount = totalCount;
		}
		
		/**
		 */
		public Participants completedCount(int completedCount) {
			setCompletedCount(completedCount);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("completedCount")
		@javax.validation.constraints.NotNull
		public int getCompletedCount() {
			return this.completedCount;
		}
		public void setCompletedCount(int completedCount) {
			this.completedCount = completedCount;
		}
		
		/**
		 */
		public Participants inProgressCount(int inProgressCount) {
			setInProgressCount(inProgressCount);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("inProgressCount")
		@javax.validation.constraints.NotNull
		public int getInProgressCount() {
			return this.inProgressCount;
		}
		public void setInProgressCount(int inProgressCount) {
			this.inProgressCount = inProgressCount;
		}
		
		/**
		 */
		public Participants notStartedCount(int notStartedCount) {
			setNotStartedCount(notStartedCount);
			return this;
		}
		
		@io.swagger.annotations.ApiModelProperty(required = true, value = "")
		@com.fasterxml.jackson.annotation.JsonProperty("notStartedCount")
		@javax.validation.constraints.NotNull
		public int getNotStartedCount() {
			return this.notStartedCount;
		}
		public void setNotStartedCount(int notStartedCount) {
			this.notStartedCount = notStartedCount;
		}
		
		@Override
		public boolean equals(java.lang.Object o) {
			if (this == o) {
				return true;
			}
			if (o == null || getClass() != o.getClass()) {
				return false;
			}
			Participants participants = (Participants) o;
			return java.util.Objects.equals(this.totalCount, participants.totalCount) &&
					java.util.Objects.equals(this.completedCount, participants.completedCount) &&
					java.util.Objects.equals(this.inProgressCount, participants.inProgressCount) &&
					java.util.Objects.equals(this.notStartedCount, participants.notStartedCount);
		}
		
		@Override
		public int hashCode() {
			return java.util.Objects.hash(this.totalCount, this.completedCount, this.inProgressCount, this.notStartedCount);
		}
		
		@Override
		public String toString() {
			StringBuilder sb = new StringBuilder();
			sb.append("class Participants {\n");
			
			sb.append("    totalCount: ").append(toIndentedString(this.totalCount)).append("\n");
			sb.append("    completedCount: ").append(toIndentedString(this.completedCount)).append("\n");
			sb.append("    inProgressCount: ").append(toIndentedString(this.inProgressCount)).append("\n");
			sb.append("    notStartedCount: ").append(toIndentedString(this.notStartedCount)).append("\n");
			sb.append("}");
			return sb.toString();
		}
		
		/**
		 * Convert the given object to string with each line indented by 4 spaces
		 * (except the first line).
		 */
		private String toIndentedString(java.lang.Object o) {
			if (o == null) {
				return "null";
			}
			return o.toString().replace("\n", "\n    ");
		}
		
	}
	
	private java.util.UUID id = null;
	private java.lang.String name = null;
	private com.example.model.SurveyTemplate template = null;
	private com.example.model.SurveySummary.StatusEnum status = null;
	private java.time.OffsetDateTime lastModified = null;
	private boolean archived = false;
	private com.example.model.SurveySummary.Participants participants = null;
	private com.example.model.Scheduling scheduling = null;
	private java.time.OffsetDateTime whenOpen = null;
	private java.time.OffsetDateTime whenClosed = null;
	
	/**
	 */
	public SurveySummary id(java.util.UUID id) {
		setId(id);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("id")
	@javax.validation.constraints.NotNull
	public java.util.UUID getId() {
		return this.id;
	}
	public void setId(java.util.UUID id) {
		this.id = id;
	}
	
	/**
	 */
	public SurveySummary name(java.lang.String name) {
		setName(name);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("name")
	@javax.validation.constraints.NotNull
	public java.lang.String getName() {
		return this.name;
	}
	public void setName(java.lang.String name) {
		this.name = name;
	}
	
	/**
	 * A survey template that can be used to create a survey
	 */
	public SurveySummary template(com.example.model.SurveyTemplate template) {
		setTemplate(template);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "A survey template that can be used to create a survey")
	@com.fasterxml.jackson.annotation.JsonProperty("template")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.SurveyTemplate getTemplate() {
		return this.template;
	}
	public void setTemplate(com.example.model.SurveyTemplate template) {
		this.template = template;
	}
	
	/**
	 */
	public SurveySummary status(com.example.model.SurveySummary.StatusEnum status) {
		setStatus(status);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("status")
	@javax.validation.constraints.NotNull
	public com.example.model.SurveySummary.StatusEnum getStatus() {
		return this.status;
	}
	public void setStatus(com.example.model.SurveySummary.StatusEnum status) {
		this.status = status;
	}
	
	/**
	 */
	public SurveySummary lastModified(java.time.OffsetDateTime lastModified) {
		setLastModified(lastModified);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("lastModified")
	@javax.validation.constraints.NotNull
	public java.time.OffsetDateTime getLastModified() {
		return this.lastModified;
	}
	public void setLastModified(java.time.OffsetDateTime lastModified) {
		this.lastModified = lastModified;
	}
	
	/**
	 */
	public SurveySummary archived(boolean archived) {
		setArchived(archived);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("archived")
	@javax.validation.constraints.NotNull
	public boolean isArchived() {
		return this.archived;
	}
	public void setArchived(boolean archived) {
		this.archived = archived;
	}
	
	/**
	 */
	public SurveySummary participants(com.example.model.SurveySummary.Participants participants) {
		setParticipants(participants);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(required = true, value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("participants")
	@javax.validation.Valid
	@javax.validation.constraints.NotNull
	public com.example.model.SurveySummary.Participants getParticipants() {
		return this.participants;
	}
	public void setParticipants(com.example.model.SurveySummary.Participants participants) {
		this.participants = participants;
	}
	
	/**
	 */
	public SurveySummary scheduling(com.example.model.Scheduling scheduling) {
		setScheduling(scheduling);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("scheduling")
	@javax.validation.Valid
	public com.example.model.Scheduling getScheduling() {
		return this.scheduling;
	}
	public void setScheduling(com.example.model.Scheduling scheduling) {
		this.scheduling = scheduling;
	}
	
	/**
	 */
	public SurveySummary whenOpen(java.time.OffsetDateTime whenOpen) {
		setWhenOpen(whenOpen);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenOpen")
	public java.time.OffsetDateTime getWhenOpen() {
		return this.whenOpen;
	}
	public void setWhenOpen(java.time.OffsetDateTime whenOpen) {
		this.whenOpen = whenOpen;
	}
	
	/**
	 */
	public SurveySummary whenClosed(java.time.OffsetDateTime whenClosed) {
		setWhenClosed(whenClosed);
		return this;
	}
	
	@io.swagger.annotations.ApiModelProperty(value = "")
	@com.fasterxml.jackson.annotation.JsonProperty("whenClosed")
	public java.time.OffsetDateTime getWhenClosed() {
		return this.whenClosed;
	}
	public void setWhenClosed(java.time.OffsetDateTime whenClosed) {
		this.whenClosed = whenClosed;
	}
	
	@Override
	public boolean equals(java.lang.Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		SurveySummary surveySummary = (SurveySummary) o;
		return java.util.Objects.equals(this.id, surveySummary.id) &&
				java.util.Objects.equals(this.name, surveySummary.name) &&
				java.util.Objects.equals(this.template, surveySummary.template) &&
				java.util.Objects.equals(this.status, surveySummary.status) &&
				java.util.Objects.equals(this.lastModified, surveySummary.lastModified) &&
				java.util.Objects.equals(this.archived, surveySummary.archived) &&
				java.util.Objects.equals(this.participants, surveySummary.participants) &&
				java.util.Objects.equals(this.scheduling, surveySummary.scheduling) &&
				java.util.Objects.equals(this.whenOpen, surveySummary.whenOpen) &&
				java.util.Objects.equals(this.whenClosed, surveySummary.whenClosed);
	}
	
	@Override
	public int hashCode() {
		return java.util.Objects.hash(this.id, this.name, this.template, this.status, this.lastModified, this.archived, this.participants, this.scheduling, this.whenOpen, this.whenClosed);
	}
	
	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("class SurveySummary {\n");
		
		sb.append("    id: ").append(toIndentedString(this.id)).append("\n");
		sb.append("    name: ").append(toIndentedString(this.name)).append("\n");
		sb.append("    template: ").append(toIndentedString(this.template)).append("\n");
		sb.append("    status: ").append(toIndentedString(this.status)).append("\n");
		sb.append("    lastModified: ").append(toIndentedString(this.lastModified)).append("\n");
		sb.append("    archived: ").append(toIndentedString(this.archived)).append("\n");
		sb.append("    participants: ").append(toIndentedString(this.participants)).append("\n");
		sb.append("    scheduling: ").append(toIndentedString(this.scheduling)).append("\n");
		sb.append("    whenOpen: ").append(toIndentedString(this.whenOpen)).append("\n");
		sb.append("    whenClosed: ").append(toIndentedString(this.whenClosed)).append("\n");
		sb.append("}");
		return sb.toString();
	}
	
	/**
	 * Convert the given object to string with each line indented by 4 spaces
	 * (except the first line).
	 */
	private String toIndentedString(java.lang.Object o) {
		if (o == null) {
			return "null";
		}
		return o.toString().replace("\n", "\n    ");
	}
	
}
