package com.example;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class AdminApiTest {
	
	private static Server server;
	private com.example.AdminApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@Before
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.AdminApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@After
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void createAccountTest() {

		Response response = this.api.createAccount();
		Assert.assertNotNull(response);
		com.example.model.AccountDetails result = response.readEntity(com.example.model.AccountDetails.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void getAccountsTest() {
		java.lang.String cursor = null;

		Response response = this.api.getAccounts(cursor);
		Assert.assertNotNull(response);
		com.example.model.GetAccounts200Response result = response.readEntity(com.example.model.GetAccounts200Response.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void searchAccountsTest() {
		java.lang.String query = null;
		java.lang.String cursor = null;

		Response response = this.api.searchAccounts(query, cursor);
		Assert.assertNotNull(response);
		com.example.model.SearchAccounts200Response result = response.readEntity(com.example.model.SearchAccounts200Response.class);
		Assert.assertNotNull(result);
	}

}
