package com.example;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class KnowledgeBaseApiTest {
	
	private static Server server;
	private com.example.KnowledgeBaseApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@Before
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.KnowledgeBaseApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@After
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void getArticleTest() {
		java.util.UUID articleId = null;

		Response response = this.api.getArticle(articleId);
		Assert.assertNotNull(response);
		com.example.model.Article result = response.readEntity(com.example.model.Article.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void getTopicTest() {
		java.util.UUID topicId = null;

		Response response = this.api.getTopic(topicId);
		Assert.assertNotNull(response);
		com.example.model.Topic result = response.readEntity(com.example.model.Topic.class);
		Assert.assertNotNull(result);
	}

}
