package com.example;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class ParticipationApiTest {
	
	private static Server server;
	private com.example.ParticipationApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@Before
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.ParticipationApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@After
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void getParticipationReportTest() {
		java.util.UUID participationId = null;

		Response response = this.api.getParticipationReport(participationId);
		Assert.assertNotNull(response);
		com.example.model.GetParticipationReport200Response result = response.readEntity(com.example.model.GetParticipationReport200Response.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void postAnswerTest() {
		java.util.UUID participationId = null;

		Response response = this.api.postAnswer(participationId);
		Assert.assertNotNull(response);
	}

	@Test
	public void postCompleteTest() {
		java.util.UUID participationId = null;

		Response response = this.api.postComplete(participationId);
		Assert.assertNotNull(response);
	}

}
