package com.example;

import javax.ws.rs.core.Response;

import org.apache.cxf.endpoint.Server;
import org.apache.cxf.jaxrs.client.JAXRSClientFactory;
import org.apache.cxf.jaxrs.client.WebClient;
import org.apache.cxf.jaxrs.spring.JAXRSServerFactoryBeanDefinitionParser.SpringJAXRSServerFactoryBean;
import org.apache.cxf.transport.local.LocalConduit;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = { TestConfiguration.class })
public class ParticipationsApiTest {
	
	private static Server server;
	private com.example.ParticipationsApi api;
	
	@Autowired
	private SpringJAXRSServerFactoryBean serverFactory;

	@Before
	public void setup() throws Exception {
		server = serverFactory.create();
		api = JAXRSClientFactory.create(TestConfiguration.ENDPOINT_ADDRESS, com.example.ParticipationsApi.class, TestConfiguration.defaultProviders());
		WebClient.getConfig(api).getRequestContext().put(LocalConduit.DIRECT_DISPATCH, Boolean.TRUE);
	}
	
	@After
	public void destroy() throws Exception {
		server.stop();
		server.destroy();
	}
	
	@Test
	public void createParticipationTest() {
		java.lang.String surveyToken = null;
		java.lang.String emailAddress = null;

		Response response = this.api.createParticipation(surveyToken, emailAddress);
		Assert.assertNotNull(response);
	}

	@Test
	public void findParticipationInfoTest() {
		java.lang.String token = null;

		Response response = this.api.findParticipationInfo(token);
		Assert.assertNotNull(response);
		com.example.model.FindParticipationInfo200Response result = response.readEntity(com.example.model.FindParticipationInfo200Response.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void findSurveyByTokenTest() {
		java.lang.String surveyToken = null;

		Response response = this.api.findSurveyByToken(surveyToken);
		Assert.assertNotNull(response);
		com.example.model.ParticipationSurvey result = response.readEntity(com.example.model.ParticipationSurvey.class);
		Assert.assertNotNull(result);
	}

	@Test
	public void getParticipationSurveyTest() {
		java.util.UUID participationId = null;

		Response response = this.api.getParticipationSurvey(participationId);
		Assert.assertNotNull(response);
		com.example.model.ParticipationSurvey result = response.readEntity(com.example.model.ParticipationSurvey.class);
		Assert.assertNotNull(result);
	}

}
